
\begin{exercise}{7.4}
  I use \texttt{keras} Python package to implement the neural net.
  
  I've used \href{https://stats.stackexchange.com/questions/181/how-to-choose-the-number-of-hidden-layers-and-nodes-in-a-feedforward-neural-netw}{this resource} in order to tune the hidden layer. The net has only one hidden layer, with 35 neurons; I've tested that using many more layers or neurons does not improve the results.
  
   The min-batch size is 10, as emerged from exercise 7.1; the training is stopped when the validation accuracy does not increase significantly for a couple of consecutive epochs. The loss function is \emph{categorical crossentropy}.
   
   After 20 epochs, finals result are
   \[
    \text{train accuracy } = 95.05\% \quad \quad \text{test accuracy } = 94.97\%.
   \]
  
  More advanced techniques, such as convolutional neural networks, can achieve accuracy on test greater than 99\%, but they are out of the scope of this exercise.
  
  \pythoncode{\RootPathSheetSeven/ex4/mnist.py}
\end{exercise}